package nl.amis.als.model.services;

import java.sql.PreparedStatement;

import java.sql.SQLException;

import nl.amis.als.model.queries.AuthorsViewImpl;
import nl.amis.als.model.queries.AuthorshipsViewImpl;
import nl.amis.als.model.queries.BooksViewImpl;
import nl.amis.als.model.queries.BorrowingsViewImpl;
import nl.amis.als.model.queries.CopiesViewImpl;
import nl.amis.als.model.queries.CurrentlyBorrowedBooksViewImpl;
import nl.amis.als.model.queries.MonthsViewImpl;
import nl.amis.als.model.queries.PublishersViewImpl;

import nl.amis.als.model.queries.RecentlyPurchasedCopiesViewImpl;

import nl.amis.als.model.queries.StaffViewROImpl;

import nl.amis.als.model.services.common.AlsService;

import oracle.jbo.CSMessageBundle;
import oracle.jbo.SQLStmtException;
import oracle.jbo.server.ViewLinkImpl;

import oracle.jheadstart.model.adfbc.v2.JhsApplicationModuleImpl;
// ---------------------------------------------------------------------
// ---    File generated by Oracle ADF Business Components Design Time.
// ---    Custom code may be added to this class.
// ---    Warning: Do not modify method signatures of generated methods.
// ---------------------------------------------------------------------
public class AlsServiceImpl extends JhsApplicationModuleImpl implements AlsService {
    /**This is the default constructor (do not remove)
     */
    public AlsServiceImpl() {
    }


    public void createBookCopies(int bokId, int numberOfCopies) {
        String statement = 
            "begin\n" + "  create_book_copies\n" + "  ( p_bok_id => :1\n" + 
            "  , p_number_of_copies => :2\n" + ",p_base_label=>:3  );\n" + "end;  \n";
        PreparedStatement plsqlStatement = 
            getDBTransaction().createPreparedStatement(statement, 0);
        try {
            plsqlStatement.setInt(1, bokId);
            plsqlStatement.setInt(2, numberOfCopies);
            plsqlStatement.setString(3, "");
            plsqlStatement.execute();
        } catch (SQLException e) {
            throw new SQLStmtException(CSMessageBundle.class, 
                                       CSMessageBundle.EXC_SQL_EXECUTE_COMMAND, 
                                       statement, e);

        } finally {
            try {
                plsqlStatement.close();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }

    /**Container's getter for AuthorshipsView1
     */
    public AuthorshipsViewImpl getAuthorshipsView1() {
        return (AuthorshipsViewImpl)findViewObject("AuthorshipsView1");
    }


    /**Container's getter for BooksView2
     */
    public BooksViewImpl getBooksView2() {
        return (BooksViewImpl)findViewObject("BooksView2");
    }


    /**Container's getter for AtpAtrFkLink1
     */
    public ViewLinkImpl getAtpAtrFkLink1() {
        return (ViewLinkImpl)findViewLink("AtpAtrFkLink1");
    }

    /**Container's getter for AtpBokFkLink1
     */
    public ViewLinkImpl getAtpBokFkLink1() {
        return (ViewLinkImpl)findViewLink("AtpBokFkLink1");
    }

    /**Container's getter for BokBokFkLink1
     */
    public ViewLinkImpl getBokBokFkLink1() {
        return (ViewLinkImpl)findViewLink("BokBokFkLink1");
    }


    /**Container's getter for BogCoyFkLink1
     */
    public ViewLinkImpl getBogCoyFkLink1() {
        return (ViewLinkImpl)findViewLink("BogCoyFkLink1");
    }

    /**Container's getter for CoyBokFkLink1
     */
    public ViewLinkImpl getCoyBokFkLink1() {
        return (ViewLinkImpl)findViewLink("CoyBokFkLink1");
    }

    /**Container's getter for BokPbrFkLink1
     */
    public ViewLinkImpl getBokPbrFkLink1() {
        return (ViewLinkImpl)findViewLink("BokPbrFkLink1");
    }

    /**Sample main for debugging Business Components code using the tester.
     */
    public static void main(String[] args) { /* package name */
            /* Configuration Name */launchTester("nl.amis.als.model.services", 
                                                 "AlsServiceLocal");
    }

    /**Container's getter for AuthorsView
     */
    public AuthorsViewImpl getAuthorsView() {
        return (AuthorsViewImpl)findViewObject("AuthorsView");
    }


    /**Container's getter for BooksView
     */
    public BooksViewImpl getBooksView() {
        return (BooksViewImpl)findViewObject("BooksView");
    }

    /**Container's getter for BorrowingsView
     */
    public BorrowingsViewImpl getBorrowingsView() {
        return (BorrowingsViewImpl)findViewObject("BorrowingsView");
    }

    /**Container's getter for CopiesView
     */
    public CopiesViewImpl getCopiesView() {
        return (CopiesViewImpl)findViewObject("CopiesView");
    }

    /**Container's getter for PublishersView
     */
    public PublishersViewImpl getPublishersView() {
        return (PublishersViewImpl)findViewObject("PublishersView");
    }

    /**Container's getter for AuthorshipsForAuthorView
     */
    public AuthorshipsViewImpl getAuthorshipsForAuthorView() {
        return (AuthorshipsViewImpl)findViewObject("AuthorshipsForAuthorView");
    }

    /**Container's getter for AuthorshipsForBookView
     */
    public AuthorshipsViewImpl getAuthorshipsForBookView() {
        return (AuthorshipsViewImpl)findViewObject("AuthorshipsForBookView");
    }


    /**Container's getter for BorrowingsOfCopyView
     */
    public BorrowingsViewImpl getBorrowingsOfCopyView() {
        return (BorrowingsViewImpl)findViewObject("BorrowingsOfCopyView");
    }

    /**Container's getter for CopiesOfBookView
     */
    public CopiesViewImpl getCopiesOfBookView() {
        return (CopiesViewImpl)findViewObject("CopiesOfBookView");
    }

    /**Container's getter for BooksForPublisherView
     */
    public BooksViewImpl getBooksForPublisherView() {
        return (BooksViewImpl)findViewObject("BooksForPublisherView");
    }

    /**Container's getter for CurrentlyBorrowedBooksView
     */
    public CurrentlyBorrowedBooksViewImpl getCurrentlyBorrowedBooksView() {
        return (CurrentlyBorrowedBooksViewImpl)findViewObject("CurrentlyBorrowedBooksView");
    }

    /**Container's getter for RecentlyPurchasedCopiesView
     */
    public RecentlyPurchasedCopiesViewImpl getRecentlyPurchasedCopiesView() {
        return (RecentlyPurchasedCopiesViewImpl)findViewObject("RecentlyPurchasedCopiesView");
    }

    /**Container's getter for StaffViewRO
     */
    public StaffViewROImpl getStaffViewRO() {
        return (StaffViewROImpl)findViewObject("StaffViewRO");
    }

    /**Container's getter for UnreturnedBorrowingsForStaffView
     */
    public BorrowingsViewImpl getUnreturnedBorrowingsForStaffView() {
        return (BorrowingsViewImpl)findViewObject("UnreturnedBorrowingsForStaffView");
    }

    /**Container's getter for UnreturnedBorrowingsLink1
     */
    public ViewLinkImpl getUnreturnedBorrowingsLink1() {
        return (ViewLinkImpl)findViewLink("UnreturnedBorrowingsLink1");
    }


    /**Container's getter for MonthsView
     */
    public MonthsViewImpl getMonthsView() {
        return (MonthsViewImpl)findViewObject("MonthsView");
    }


}
